/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the QuickbooksStaticUserAuthAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &QuickbooksStaticUserAuthAllOf{}

// QuickbooksStaticUserAuthAllOf struct for QuickbooksStaticUserAuthAllOf
type QuickbooksStaticUserAuthAllOf struct {
	ClientId     *string `json:"clientId,omitempty"`
	ClientSecret *string `json:"clientSecret,omitempty"`
	RedirectUri  *string `json:"redirectUri,omitempty"`
	Tenant       *string `json:"tenant,omitempty"`
}

// NewQuickbooksStaticUserAuthAllOf instantiates a new QuickbooksStaticUserAuthAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewQuickbooksStaticUserAuthAllOf() *QuickbooksStaticUserAuthAllOf {
	this := QuickbooksStaticUserAuthAllOf{}
	return &this
}

// NewQuickbooksStaticUserAuthAllOfWithDefaults instantiates a new QuickbooksStaticUserAuthAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewQuickbooksStaticUserAuthAllOfWithDefaults() *QuickbooksStaticUserAuthAllOf {
	this := QuickbooksStaticUserAuthAllOf{}
	return &this
}

// GetClientId returns the ClientId field value if set, zero value otherwise.
func (o *QuickbooksStaticUserAuthAllOf) GetClientId() string {
	if o == nil || IsNil(o.ClientId) {
		var ret string
		return ret
	}
	return *o.ClientId
}

// GetClientIdOk returns a tuple with the ClientId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *QuickbooksStaticUserAuthAllOf) GetClientIdOk() (*string, bool) {
	if o == nil || IsNil(o.ClientId) {
		return nil, false
	}
	return o.ClientId, true
}

// HasClientId returns a boolean if a field has been set.
func (o *QuickbooksStaticUserAuthAllOf) HasClientId() bool {
	if o != nil && !IsNil(o.ClientId) {
		return true
	}

	return false
}

// SetClientId gets a reference to the given string and assigns it to the ClientId field.
func (o *QuickbooksStaticUserAuthAllOf) SetClientId(v string) {
	o.ClientId = &v
}

// GetClientSecret returns the ClientSecret field value if set, zero value otherwise.
func (o *QuickbooksStaticUserAuthAllOf) GetClientSecret() string {
	if o == nil || IsNil(o.ClientSecret) {
		var ret string
		return ret
	}
	return *o.ClientSecret
}

// GetClientSecretOk returns a tuple with the ClientSecret field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *QuickbooksStaticUserAuthAllOf) GetClientSecretOk() (*string, bool) {
	if o == nil || IsNil(o.ClientSecret) {
		return nil, false
	}
	return o.ClientSecret, true
}

// HasClientSecret returns a boolean if a field has been set.
func (o *QuickbooksStaticUserAuthAllOf) HasClientSecret() bool {
	if o != nil && !IsNil(o.ClientSecret) {
		return true
	}

	return false
}

// SetClientSecret gets a reference to the given string and assigns it to the ClientSecret field.
func (o *QuickbooksStaticUserAuthAllOf) SetClientSecret(v string) {
	o.ClientSecret = &v
}

// GetRedirectUri returns the RedirectUri field value if set, zero value otherwise.
func (o *QuickbooksStaticUserAuthAllOf) GetRedirectUri() string {
	if o == nil || IsNil(o.RedirectUri) {
		var ret string
		return ret
	}
	return *o.RedirectUri
}

// GetRedirectUriOk returns a tuple with the RedirectUri field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *QuickbooksStaticUserAuthAllOf) GetRedirectUriOk() (*string, bool) {
	if o == nil || IsNil(o.RedirectUri) {
		return nil, false
	}
	return o.RedirectUri, true
}

// HasRedirectUri returns a boolean if a field has been set.
func (o *QuickbooksStaticUserAuthAllOf) HasRedirectUri() bool {
	if o != nil && !IsNil(o.RedirectUri) {
		return true
	}

	return false
}

// SetRedirectUri gets a reference to the given string and assigns it to the RedirectUri field.
func (o *QuickbooksStaticUserAuthAllOf) SetRedirectUri(v string) {
	o.RedirectUri = &v
}

// GetTenant returns the Tenant field value if set, zero value otherwise.
func (o *QuickbooksStaticUserAuthAllOf) GetTenant() string {
	if o == nil || IsNil(o.Tenant) {
		var ret string
		return ret
	}
	return *o.Tenant
}

// GetTenantOk returns a tuple with the Tenant field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *QuickbooksStaticUserAuthAllOf) GetTenantOk() (*string, bool) {
	if o == nil || IsNil(o.Tenant) {
		return nil, false
	}
	return o.Tenant, true
}

// HasTenant returns a boolean if a field has been set.
func (o *QuickbooksStaticUserAuthAllOf) HasTenant() bool {
	if o != nil && !IsNil(o.Tenant) {
		return true
	}

	return false
}

// SetTenant gets a reference to the given string and assigns it to the Tenant field.
func (o *QuickbooksStaticUserAuthAllOf) SetTenant(v string) {
	o.Tenant = &v
}

func (o QuickbooksStaticUserAuthAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o QuickbooksStaticUserAuthAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.ClientId) {
		toSerialize["clientId"] = o.ClientId
	}
	if !IsNil(o.ClientSecret) {
		toSerialize["clientSecret"] = o.ClientSecret
	}
	if !IsNil(o.RedirectUri) {
		toSerialize["redirectUri"] = o.RedirectUri
	}
	if !IsNil(o.Tenant) {
		toSerialize["tenant"] = o.Tenant
	}
	return toSerialize, nil
}

type NullableQuickbooksStaticUserAuthAllOf struct {
	value *QuickbooksStaticUserAuthAllOf
	isSet bool
}

func (v NullableQuickbooksStaticUserAuthAllOf) Get() *QuickbooksStaticUserAuthAllOf {
	return v.value
}

func (v *NullableQuickbooksStaticUserAuthAllOf) Set(val *QuickbooksStaticUserAuthAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableQuickbooksStaticUserAuthAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableQuickbooksStaticUserAuthAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableQuickbooksStaticUserAuthAllOf(val *QuickbooksStaticUserAuthAllOf) *NullableQuickbooksStaticUserAuthAllOf {
	return &NullableQuickbooksStaticUserAuthAllOf{value: val, isSet: true}
}

func (v NullableQuickbooksStaticUserAuthAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableQuickbooksStaticUserAuthAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
